#ifndef bqtQBlibGraphicsHH
#define bqtQBlibGraphicsHH

#include <cstdio> // for size_t

#include <qblib/string.hh>

/* Text */

void B_StmtVIEWPRINT(int from=-1, int to=-1);
int B_FuncSCREEN(int y,int x, int colorflag=0);
void B_ScreenPOKE(int x,int y, int colorflag, int value);

void B_StmtCLS(int type);
void B_StmtWIDTH(int w,int h);
void B_StmtCOLOR(int fg,int bg=-1,int border=-1);
void B_StmtLOCATE(int row,int col,int c_vis,int c_start,int c_stop=-1);
void B_StmtLOCATE(int row,int col,int c_vis);
void B_StmtLOCATE(int row,int col=-1);
static inline void B_StmtLOCATE() {} // without parameters, it does nothing

int B_FuncCSRLIN();
int B_FuncPOS(int=0);
int B_FuncWIDTH();

void GFX_OutS(const char* buffer, size_t nbytes);

/* System */

void GFX_Init();
void GFX_Done();

/* Misc */

const BAS_STR B_FuncINKEY_S(bool wait = false); // in gfx_term.cc
void B_StmtSLEEP(double duration = -1.0); // in gfx_term.cc
void B_StmtSCREEN(int mode,int color=-1,int apage=-1,int vpage=-1);

/* Graphics */

void B_StmtPALETTE(int index, int value);

void B_StmtLINE(bool step1, int x1,int y1,
                bool step2, int x2,int y2,
                int color=-1, int fill=-1, int style=-1);

void B_StmtCIRCLE(bool step, int x,int y, int radius, int color=-1, int start=-1, int end=-1, double aspect=-1);

void B_StmtPSET(bool step, int x,int y, int color=-1);
void B_StmtPRESET(bool step, int x,int y, int color=-1);
int B_FuncPOINT(int x,int y);
int B_FuncPOINT(int whattoreport);

void B_StmtPAINT(bool step, int x,int y, int paint=-1,         int border=-1,int background=-1);
void B_StmtPAINT(bool step, int x,int y, const BAS_STR& paint, int border=-1,int background=-1);

template<typename Data>
void B_StmtPALETTE_USING(Data& data);

template<typename Data>
void B_StmtPUT(bool step, int x,int y, Data& data, int putstyle=-1);

template<typename Data>
void B_StmtGET(bool step1, int x1,int y1,
               bool step2, int x2,int y2, Data& data);

void B_StmtDRAW(const BAS_STR& commands);

void B_RerenderTextScreen();

#include "gfx.tcc"


#endif
